#ifndef GREAT_H
#define GREAT_H

#include <list>
#include <stack>
#include "UdmDom.h"
#include "UdmGme.h"
#include "UmlExt.h"
#include "GR.h"
#include "IGReAT.h"

class GReAT : public IGReAT 
{

protected:
	typedef Udm::Object Object;

 	GeneralBackend* backendMap; 
	Udm::DataNetwork *grTransformation;

	IDebugNotify* m_dbgNotify;
	ICtrlNotify*  m_ctrlNotify;
public:

  GReAT();
  virtual ~GReAT();
  
//=================================
//class IGReAT 
  void init(GeneralBackendPtr  dataNetworkMap, 
            Udm::DataNetwork *Transformation);
  void setCINTDll(HINSTANCE hDLL);


  PassAlongPackets Execute(const GR::RewritingRule& rule, 
                            const PassAlongPackets& agruments);

  void setDebugNotify(IDebugNotify* );
  void setCtrlNotify(ICtrlNotify* );
  void RemoveDuplicates(PassAlongPackets& ps);

protected:
	int depth;
	double calcProgress(int depth);
	PassAlongPackets ExecuteBlock(const GR::RewritingRule& rule, const PassAlongPackets& agruments);
	PassAlongPackets ExecuteForBlock(const GR::RewritingRule& rule, const PassAlongPackets& agruments);
	PassAlongPackets ExecuteTest(const GR::RewritingRule& rule, const PassAlongPackets& agruments);
	PassAlongPackets ExecuteForTest(const GR::RewritingRule& rule, const PassAlongPackets& agruments);
	PassAlongPackets ExecuteRule(GR::RewritingRule rule, const PassAlongPackets& agruments);
	PassAlongPackets ExecuteCase(GR::RewritingRule rule, const PassAlongPackets& agruments);

	void ConvertPacket(const PassAlongPacket& p, const GR::RuleBase& dstRule, PassAlongPacket& newp);
	void ConvertPackets(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps);
	void ConvertPacketFromRefToRule(const PassAlongPacket& p,const GR::RuleBase& dstRule, PassAlongPacket& newp);
	void ConvertPacketsFromRefToRule(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps);
	void ConvertPacketFromRuleToRef(const PassAlongPacket& p,const GR::RuleBase& dstRule,PassAlongPacket& newp);
	void ConvertPacketsFromRuleToRef(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps);
	bool PackingPassAlongPacket(const GR::RewritingRule& rule, PassAlongPacket& ret);
	bool BindingMatch(const GR::RewritingRule& rule, const Match& match);
	
	bool CheckDuplicate(PassAlongPacket& p1, PassAlongPacket& p2);
	bool BindingPassAlongPacket(const GR::RewritingRule& rule, const PassAlongPacket& pkt);
	bool CheckPassAlong(const GR::RewritingRule& rule);	
	void resetGRObject(const GR::RewritingRule& rule);

	bool executeCmpFunc(const GR::PatternObject &sorted_port, const Udm::Object &lhs, const Udm::Object &rhs);
};
 
class GReATOptions
{
public:
	static GReATOptions *instance();
	static bool printRule;
	static bool printDetail;
protected:
	GReATOptions() {}
//	~GReATOptions() {delete instance_;}
	static GReATOptions *instance_;   //Singleton
};

#endif  //GREAT.H

