#ifndef GROUPEFFECTOR_H
#define GROUPEFFECTOR_H

#include "UmlExt.h"
#include "UdmBase.h"
#include "GeneralBackend.h"
#include "GReATTypes.h"
#include "UdmUtil.h"

class GroupEffector 
{
public:
	GroupEffector(GR::RewritingRule *currRule,GeneralBackend *dataNetworkMap, vector<Match> matches);
	GroupEffector();
	~GroupEffector();
	bool execute();
	PassAlongPackets getPassAlongPackets(){return _retPackets;}

protected:
	void makeGroups();
	void executeCode(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);
	bool executeGroupRule(Match &the_match, Match &other_match);
	void executeRightSide(vector<Match> &group);
	bool bindingConsequenceObject(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);
	bool getCompositionToBound(GR::ObjectWrapper &parentCO,GR::ObjectWrapper &childCO,
								Udm::Object::CompositionInfo &compInfo,
								map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);

	void bindingRemainingObjectLinks(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);
	void executeGroupAction(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs, vector<Match> &group);
	void reqDelete(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);
	void packingPassAlongPackets(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);
	void ProcessGRLink(vector<Match> &group, GR::ObjectLink &grlink,
					map<Udm::Object, pair<Udm::Object, Udm::Object> > &assoc_with_peer_end,
					map<Udm::Object, pair<string, string> > &assoc_with_rolenames, 
					map<Udm::Object, set<Udm::Object> > &set_with_members,
					map<Udm::Object, pair<string, string> > &set_with_rolenames);
	void ProcessGRAssociation(vector<Match> &group, GR::PatternObject &grAssoc,
							   map<Udm::Object, pair<Udm::Object, Udm::Object> > &assoc_with_peer_end,
							   map<Udm::Object, pair<string, string> > &assoc_with_rolenames);
	void CopyGroup(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs, set<Udm::Object> &groupObjs,
				   map<Udm::Object, pair<Udm::Object, Udm::Object> > &assoc_with_peer_end,
				   map<Udm::Object, pair<string, string> > &assoc_with_rolenames, 
				   map<Udm::Object, set<Udm::Object> > &set_with_members,
				   map<Udm::Object, pair<string, string> > &set_with_rolenames);
	void MoveGroup(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs, set<Udm::Object> &groupObjs,
				   map<Udm::Object, pair<Udm::Object, Udm::Object> > &assoc_with_peer_end,
				   map<Udm::Object, pair<string, string> > &assoc_with_rolenames, 
				   map<Udm::Object, set<Udm::Object> > &set_with_members,
				   map<Udm::Object, pair<string, string> > &set_with_rolenames);
	void DeleteGroup(vector<Match> &group, set<GR::ObjectLink> &groupLinks, 
					set<Udm::Object> &groupAssocs, set<Udm::Object> &groupObjs);

	bool GetCopyPeer(Udm::Object &fromObj, Udm::Object &toObj, Udm::Object &fromParent, Udm::Object &copy_Parent,  
					map<pair<Udm::Object, Udm::Object>, UdmUtil::copy_assoc_map>& copyMap);
	void makeInstCopyAssocMap(Udm::Object &from_obj, Udm::Object &to_obj, UdmUtil::copy_assoc_map &copy_map);
	void list2set(list<Udm::Object> &listObjs, set<Udm::Object> &setObjs);	
	void createRTT(map<GR::ObjectWrapper, list<Udm::Object> > &boundObjs);

	GR::RewritingRule *boundRule;
	GeneralBackend* backendMap;
	vector<Match> _matches;
	GR::PatternGroup _group;
	vector< vector<Match> > groupMatches;
	PassAlongPackets _retPackets;
};

#endif //GROUPEFFECTOR_H
