#ifndef GRCLOADER_H
#define GRCLOADER_H

#include <string>
#include <list>
#include <windows.h>	// for HINSTANCE
#include "Uml.h"
#include "GRCExport.h"

///////////////////////////////////////////////////////////////////////////////
typedef std::list< std::pair< std::string, Uml::Diagram> >  StrUmlDiagrams_t;

///////////////////////////////////////////////////////////////////////////////
class GRCC_DLL GRCLoader {
public:
	GRCLoader( const std::string& dllFullName, const StrUmlDiagrams_t& metas)
		: _dllFullName( dllFullName), _metas( metas), _hDLL( 0)
	{}
	HINSTANCE loadDll();
	void closeDll();

private:
	std::string _dllFullName;
	StrUmlDiagrams_t _metas;
	HINSTANCE _hDLL;
};

#endif // GRCLOADER_H
