import os
import unittest

class TestGreatSamplesCmd(unittest.TestCase):

    def setUp(self):
        self.dir = os.getcwd()

    def tearDown(self):
        os.chdir(self.dir)

    def testHouse2Order(self):
        # make sure House2Order sample runs
        os.chdir('../Samples/House2Order')
        returnCode = os.system('gre.exe Config.mga')
        #print returnCode
        if (returnCode != 3):
            self.assert_(1) #House2Order did run
        else:
            self.assert_(0) #House2Order did not run

    def testSF2FSF(self):
        # make sure SF2FSF sample runs
        os.chdir('../Samples/SignalFlow2FlatSF')
        returnCode = os.system('gre.exe Config.mga')
        #print returnCode
        if (returnCode != 3):
            self.assert_(1) #SF2FSF did run
        else:
            self.assert_(0) #SF2FSF did not run

    def testStateChart(self):
        # make sure StateChart sample runs
        os.chdir('../Samples/StateChart')
        returnCode = os.system('gre.exe Config.mga')
        #print returnCode
        if (returnCode != 3):
            self.assert_(1) #StateChart did run
        else:
            self.assert_(0) #StateChart did not run

if __name__ == '__main__':
    unittest.main()
    
def suite():
    suite = unittest.makeSuite(TestGreatSamplesCmd)
    return suite
