#include "EventQueue.h"
//#include "../Log/Log.h"
//extern Log lout;

namespace GRDI
{

//======================================

EventQueue::EventQueue(int maxSize) : m_maxSize(maxSize)
{
}

//======================================
void EventQueue::insert (EventSet event)
{
  Lock lk(m_mutex);

  while (m_maxSize == m_queue.size())
      m_not_full.wait(lk);

  m_queue.push_back(event);

  m_not_empty.notify_one();

//  lout.print(1,"EventQueue","Event is inserted\n");
}

//======================================

EventSet EventQueue::remove()
{
  Lock lk(m_mutex);
  while (!m_queue.size())
    m_not_empty.wait(lk);

  EventSet  ev = m_queue.front();
  m_queue.pop_front();
  m_not_full.notify_one();

//  lout.print(1,"EventQueue","Event is removed\n");

  return ev;
}

}; //namespace GRDI

