
#include <sstream>
#include "GReATDebugger.h"
#include "GReATDebuggerVars.h"
#include "../GRDBackEnd/IGRDBackend.h"
#include "GReATParametersFactory.h"
#include "GReATFactory.h"

//========== GRDebuggeeAPI
//=========================================


void GReATDebugger::setWD(const std::string& wd)
{
  m_workingDirectory = wd;
}



void GReATDebugger::load(const std::string& paramFileName)
{
  m_paramFileName = paramFileName;
  m_init = true;
}

//=========================================
void GReATDebugger::run()
{
  m_great = GReATFactory::create();
  m_up = true;
  while(!m_init);
  m_great->setCtrlNotify(this);
  if(!m_debugMode)
  {
   runNonDebugMode();
  }
  else
  {
    m_great->setDebugNotify(this);
    runDebugMode();
  }

  if (m_great)
    delete m_great, m_great = 0;
  
  m_up = false;
}
//=========================================
void GReATDebugger::wait_up()
{
  while(!m_up);
}
//=========================================
void GReATDebugger::stop()
{
  m_quitNonDebug = true;
}

//=========================================
void GReATDebugger::setGRDBackEnd(GRDI::IGRDBackEnd*  back)
{ 
  m_debugMode = true; 
  m_back = back;
  m_init = true; // FIXME: UNSAFE: referenced on line 31 in another thread
}
