// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Thursday, November 16, 2006 14:13:47



#include "stdafx.h"
#include "UdmApp.h"
#include "UdmConfig.h"
#include "Uml.h"
#include "CompareFunction.h"
#include <set>
#include <map>
#include <string>

typedef map<UMLModelTransformer::PatternClass, UMLModelTransformer::Out> POMap;

int CUdmApp::Initialize()
{

	// TODO: Your initialization code comes here...
	return 0;
}

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/

void CreateRule(UMLModelTransformer::Rule& r, Udm::DataNetwork* p_backend);

void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 set<Udm::Object> selectedObjects,	// Selected objects
					 long param)						// Parameters
{	
	
	if(selectedObjects.size() != 1)
		return;

	Udm::Object ob = (*(selectedObjects.begin()));

	if(!Uml::IsDerivedFrom(ob.type(), UMLModelTransformer::Rule::meta))
		return;

	//We want to create the next rule after rule
	UMLModelTransformer::Rule rule = UMLModelTransformer::Rule::Cast(ob);

	CreateRule(rule, p_backend);													
}

void CreatePorts(UMLModelTransformer::Rule& r, POMap& p, Udm::DataNetwork* p_backend);
int GetPortCoord(const UMLModelTransformer::Port& port, bool yCoord=true);
void SetPortCoords(UMLModelTransformer::Port& port, int x, int y);

void CreateRule(UMLModelTransformer::Rule& r, Udm::DataNetwork* p_backend)
{
	UMLModelTransformer::CompoundRule parent = r.CompoundRule_parent();

	POMap portMap;

	set<UMLModelTransformer::Binding> bmb = r.Binding_kind_children();
	for(set<UMLModelTransformer::Binding>::iterator it = bmb.begin(); it != bmb.end(); ++it)
	{
		UMLModelTransformer::Binding_Members_Base currB = (*it).srcBinding_end();
		if(Uml::IsDerivedFrom(currB.type(), UMLModelTransformer::PatternClass::meta))
		{
			UMLModelTransformer::PatternClass pc = UMLModelTransformer::PatternClass::Cast(currB);
			UMLModelTransformer::Out currOut = UMLModelTransformer::Out::Cast((*it).dstBinding_end());
			portMap.insert(pair<UMLModelTransformer::PatternClass, UMLModelTransformer::Out>(pc, currOut));
		}
	}

	if(portMap.empty())
		return;

	UMLModelTransformer::Rule newRule = UMLModelTransformer::Rule::Create(parent);
	std::string prevRuleName = r.name();
	prevRuleName.append("N");
	newRule.name() = prevRuleName;
	newRule.position() = r.position();

	std::string p1 = r.position();
	std::string p2 = newRule.position();

	SetCoord(newRule, GetCoord(newRule,false)+200,GetCoord(newRule));

	CreatePorts(newRule,portMap, p_backend);

}

void CreatePorts(UMLModelTransformer::Rule& r, POMap& pMap, Udm::DataNetwork* p_backend)
{
	UMLModelTransformer::CompoundRule parent = r.CompoundRule_parent();  //we create the Sequence connections in here
	for(POMap::iterator it = pMap.begin();it != pMap.end();++it)
	{
		UMLModelTransformer::PatternClass pc = (*it).first;
		UMLModelTransformer::Out out = (*it).second;

		UMLModelTransformer::In in = UMLModelTransformer::In::Create(r);
		UMLModelTransformer::PatternClass newPC = UMLModelTransformer::PatternClass::Create(r);
		UMLModelTransformer::Binding bind = UMLModelTransformer::Binding::Create(r);
		UMLModelTransformer::Sequence seq = UMLModelTransformer::Sequence::Create(parent);

		newPC.ref() = pc.ref();
		newPC.name() = pc.name();
		in.name() = "In";

		bind.srcBinding_end() = in;
		bind.dstBinding_end() = newPC;
		seq.srcSequence_end() = out;
		seq.dstSequence_end() = in;	

		p_backend->CommitEditSequence();

		SetPortCoords(in, 20, GetPortCoord(out)+14);
		SetCoord(newPC, 100, (GetPortCoord(in)-26));

	}
}

int GetPortCoord(const UMLModelTransformer::Port& port, bool WantYCoord)
{
	std::string pos =port.position();
	std::string::size_type findComma= pos.find( ',');
	std::string x = pos.substr(1,findComma-1);
	std::string y = pos.substr(findComma+1, pos.length()-2);

	if(WantYCoord)
		return (atoi(y.c_str()));
	return (atoi(x.c_str()));
}

void SetPortCoords(UMLModelTransformer::Port& port, int x, int y)
{
	//debugging
	std::string temp = port.position();

	char yBuf[5], xBuf[5];
	_itoa_s(y,yBuf,10);
	std::string yStr(yBuf);
	_itoa_s(x, xBuf, 10);
	std::string xStr(xBuf);

	std::string newPos = "(";
	newPos.append(xStr);
	newPos.append(",");
	newPos.append(yStr);
	newPos.append(")");
	port.position() = newPos;
}

#ifdef _DEBUG
/*****************************************************/
/* Debug time helper function. If the object has an  */
/* attribute called "name", this function retreives  */
/* it to help you to find it in the model during the */
/* application development.	Usualy every GME Object	 */
/* has a "name" attribute. If an object hapens not	 */
/* to have it,function retreives <no name specified>.*/
/*****************************************************/
string CUdmApp::ExtractName(Udm::Object ob)
{
	Uml::Class cls= ob.type();				
	set<Uml::Attribute> attrs=cls.attributes();		
	
	// Adding parent attributes
	set<Uml::Attribute> aattrs=Uml::AncestorAttributes(cls);
	attrs.insert(aattrs.begin(),aattrs.end());

	for(set<Uml::Attribute>::iterator ai = attrs.begin();ai != attrs.end(); ai++) 
	{
		if(string(ai->type())=="String")
		{
			string str=ai->name();
			if(str=="name")
			{
				string value=ob.getStringAttr(*ai);
				if(value.empty())value="<empty string>";
				return value;
			}			
		}				
	}	
	return string("<no name specified>");
}
#endif
