// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Wednesday, November 02, 2005 18:38:43



#include "stdafx.h"
#include "UdmApp.h"
#include "UdmConfig.h"
#include "GenMyTransform.h"
#include "MyTransform-gr_cmptempl.h"
#include "PortSorters.h"

typedef std::list< Udm::Object> Packets_t;

/*********************************************************************************/
/* Initialization function. The framework calls it before preparing the backend. */
/* Initialize here the settings in the config global object.					  */
/* Return 0 if successful.														  */
/*********************************************************************************/
int CUdmApp::Initialize()
{

	// TODO: Your initialization code comes here...
	return 0;
}

/* 
Remarks to CUdmApp::UdmMain(...):
0.	The p_backend points to an already open backend, and the framework 
	closes it automatically. DO NOT OPEN OR CLOSE IT!
	To commit changes use p_backend->CommitEditSequence().
	To abort changes use p_backend->AbortEditSequence().
	To save changes to a different file use p_backend->SaveAs() or p_backend->CloseAs().

1.	Focus is the currently open model.

2.	The possible values for param (from GME DecoratorLib.h component_startmode_enum):
	GME_MAIN_START			=   0,
	GME_BROWSER_START		=   1,
	GME_CONTEXT_START		=   2,
	GME_EMBEDDED_START		=   3,
	GME_MENU_START			=  16,
	GME_BGCONTEXT_START		=  18,
	GME_ICON_START			=  32,
	METAMODEL_CHECK_SYNTAX	= 101

 3. The framework catches all the exceptions and reports the error in a message box,
	clean up and close the transactions aborting the changes. You can override this 
	behavior by catching udm_exception. Use udm_exception::what() to form an error 
	message.
*/

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/

void callConnectPorts_5d( const Packets_t& outs_9, const Packets_t& ins_b)
{
	ConnectPorts_21 connectPorts_21;
	connectPorts_21( outs_9, ins_b);
}

template <class T, class V> 
	bool sortInput(const T& lhs, const V& rhs)
{
	std::string lhs_pos= lhs.position();
	std::string rhs_pos= rhs.position();

	std::string::size_type findTrans = lhs_pos.find("Transform");
	if(findTrans == std::string::npos)
		AfxMessageBox("Couldn't find position correctly");
	lhs_pos = lhs_pos.substr(findTrans);
	//std::cout << "Now lhs_pos = " << lhs_pos << std::endl;
	findTrans = lhs_pos.find("(");
	lhs_pos = lhs_pos.substr(findTrans+1);
	lhs_pos = lhs_pos.substr(0,lhs_pos.size()-2);
	//std::cout << "After trim lhs_pos = " << lhs_pos << std::endl;
	findTrans = lhs_pos.find(',');
	int lhs_x = atoi(lhs_pos.substr(0,findTrans).c_str());

	findTrans = rhs_pos.find("Transform");
	rhs_pos = rhs_pos.substr(findTrans);
	findTrans = rhs_pos.find("(");
	rhs_pos = rhs_pos.substr(findTrans+1);
	rhs_pos = rhs_pos.substr(0, rhs_pos.size()-2);
	findTrans = rhs_pos.find(',');
	int rhs_x = atoi(rhs_pos.substr(0,findTrans).c_str());

	//std::cout << "LHSX = " << lhs_x << " and RHSX = " << rhs_x << std::endl;

	return (lhs_x<rhs_x);
}

void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 set<Udm::Object> selectedObjects,	// Selected objects
					 long param)						// Parameters
{	
	size_t sizeOfIncoming = selectedObjects.size();

	// Case where we have two expressions
	
	if(sizeOfIncoming == 2)  {
		set<Udm::Object>::const_iterator it = selectedObjects.begin();
		Udm::Object first, second;
		set<UMLModelTransformer::In, ObjectSorterIn> inPortsConnect;
		set<UMLModelTransformer::Out, ObjectSorterOut> outPortsConnect;
		first = *it; ++it; second = *it;
		Uml::Class firstClass, secondClass; firstClass = first.type(); secondClass = second.type();

		UMLModelTransformer::Expression exp1, exp2, expTemp;
		UMLModelTransformer::ExpressionRef expRef1, expRef2, expRefTemp;

		//first is expression and second is also expression
		if((Uml::IsDerivedFrom(firstClass, UMLModelTransformer::Expression::meta)) && (Uml::IsDerivedFrom(secondClass, UMLModelTransformer::Expression::meta)))
		{
			exp1 = UMLModelTransformer::Expression::Cast(first);
			exp2 = UMLModelTransformer::Expression::Cast(second);
			if(!sortInput(exp1,exp2))  //swap them if exp2 is to the left of the other
			{
				expTemp = exp1; exp1 = exp2; exp2 = expTemp;
			}
            ObjectSorterIn osi; ObjectSorterOut oso;
			inPortsConnect = exp2.In_kind_children_sorted(osi);
			outPortsConnect = exp1.Out_kind_children_sorted(oso);

			set<UMLModelTransformer::In, ObjectSorterIn>::iterator sit = inPortsConnect.begin();
			set<UMLModelTransformer::Out, ObjectSorterOut>::iterator sot = outPortsConnect.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (sit != inPortsConnect.end()) && (sot != outPortsConnect.end()); ++sit, ++ sot)
			{
				UMLModelTransformer::Sequence newSequence = UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *sot;
				newSequence.dstSequence_end()= *sit;
			}
		}

		else if((Uml::IsDerivedFrom(firstClass, UMLModelTransformer::Expression::meta)) && (secondClass == UMLModelTransformer::ExpressionRef::meta))
		{
			exp1 = UMLModelTransformer::Expression::Cast(first);
			expRef1 = UMLModelTransformer::ExpressionRef::Cast(second);
			exp2 = expRef1.ref();
			if(!sortInput(exp1,expRef1))  //swap them if exp2 is to the left of the other
			{
				expTemp = exp1; exp1 = exp2; exp2 = expTemp;
			}
            ObjectSorterIn osi; ObjectSorterOut oso;
			inPortsConnect = exp2.In_kind_children_sorted(osi);
			outPortsConnect = exp1.Out_kind_children_sorted(oso);

			set<UMLModelTransformer::In, ObjectSorterIn>::iterator sit = inPortsConnect.begin();
			set<UMLModelTransformer::Out, ObjectSorterOut>::iterator sot = outPortsConnect.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (sit != inPortsConnect.end()) && (sot != outPortsConnect.end()); ++sit, ++ sot)
			{
				UMLModelTransformer::Sequence newSequence = UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *sot;
				newSequence.dstSequence_end()= *sit;
			}
		}

		else if((firstClass == UMLModelTransformer::ExpressionRef::meta) && (Uml::IsDerivedFrom(secondClass, UMLModelTransformer::Expression::meta)))
		{
			exp1 = UMLModelTransformer::Expression::Cast(second);
			expRef1 = UMLModelTransformer::ExpressionRef::Cast(first);
			exp2 = expRef1.ref();
			if(!sortInput(exp1,expRef1))  //swap them if exp2 is to the left of the other
			{
				expTemp = exp1; exp1 = exp2; exp2 = expTemp;
			}
            ObjectSorterIn osi; ObjectSorterOut oso;
			inPortsConnect = exp2.In_kind_children_sorted(osi);
			outPortsConnect = exp1.Out_kind_children_sorted(oso);

			set<UMLModelTransformer::In, ObjectSorterIn>::iterator sit = inPortsConnect.begin();
			set<UMLModelTransformer::Out, ObjectSorterOut>::iterator sot = outPortsConnect.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (sit != inPortsConnect.end()) && (sot != outPortsConnect.end()); ++sit, ++ sot)
			{
				UMLModelTransformer::Sequence newSequence = UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *sot;
				newSequence.dstSequence_end()= *sit;
			}
		}

		else if((firstClass == UMLModelTransformer::ExpressionRef::meta) && (secondClass == UMLModelTransformer::ExpressionRef::meta))
		{
			expRef1 = UMLModelTransformer::ExpressionRef::Cast(first);
			expRef2 = UMLModelTransformer::ExpressionRef::Cast(second);
			exp1 = expRef1.ref();
			exp2 = expRef2.ref();
			if(!sortInput(expRef1,expRef2))  //swap them if exp2 is to the left of the other
			{
				expTemp = exp1; exp1 = exp2; exp2 = expTemp;
			}
            ObjectSorterIn osi; ObjectSorterOut oso;
			inPortsConnect = exp2.In_kind_children_sorted(osi);
			outPortsConnect = exp1.Out_kind_children_sorted(oso);

			set<UMLModelTransformer::In, ObjectSorterIn>::iterator sit = inPortsConnect.begin();
			set<UMLModelTransformer::Out, ObjectSorterOut>::iterator sot = outPortsConnect.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (sit != inPortsConnect.end()) && (sot != outPortsConnect.end()); ++sit, ++ sot)
			{
				UMLModelTransformer::Sequence newSequence = UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *sot;
				newSequence.dstSequence_end()= *sit;
			}
		}

	}

	// Case where we have multiple input ports and one expression passed in

	try
	{
		list<UMLModelTransformer::In> inPorts;				//all the input ports to connect
		set<UMLModelTransformer::In, ObjectSorterIn> inPortsConnect;	//the ports to which we are connecting
		UMLModelTransformer::Expression onlyExpr;	//the Expression
		bool alreadySeenExpression = false;
		bool isThisCase = true;

		for(set<Udm::Object>::iterator it = selectedObjects.begin(); it != selectedObjects.end(); ++it)
		{
			if(((*it).type()) == UMLModelTransformer::In::meta)
			{
				UMLModelTransformer::In currIn = UMLModelTransformer::In::Cast(*it);
				inPorts.push_back(currIn);
			}

			else if(Uml::IsDerivedFrom( (*it).type(), UMLModelTransformer::Expression::meta))
			{
				if(!alreadySeenExpression)
				{
					onlyExpr = UMLModelTransformer::Expression::Cast(*it);
					alreadySeenExpression = true;
				}
				else isThisCase = false;  //we can't have 2 expressions in this case
			}

			else if(((*it).type()) == UMLModelTransformer::ExpressionRef::meta)
			{
				if(!alreadySeenExpression)
				{
					UMLModelTransformer::ExpressionRef tempRef = UMLModelTransformer::ExpressionRef::Cast(*it);
					onlyExpr = tempRef.ref();
					alreadySeenExpression = true;
				}
				else isThisCase = false;
			}

			else isThisCase = false;
		}

		if(isThisCase) {
			//Now we need to sort the InPorts, find all of the Inports in the Expression, then connect them
			inPorts.sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::In>));
			ObjectSorterIn os;
			inPortsConnect = onlyExpr.In_kind_children_sorted(os);
			
			set<UMLModelTransformer::In, ObjectSorterIn>::iterator sit = inPortsConnect.begin();
			list<UMLModelTransformer::In>::iterator lit = inPorts.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (lit != inPorts.end()) && (sit != inPortsConnect.end()); ++lit, ++ sit)
			{
				UMLModelTransformer::Sequence newSequence= UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *lit;
				newSequence.dstSequence_end()= *sit;
			}
			return;
		}		
	}

	catch(udm_exception& e)
	{
		AfxMessageBox(e.what(),MB_OK);
	}

	// Now the case where we have outputs to outputs
	try
	{
		list<UMLModelTransformer::Out> outPorts;				//all the input ports to connect
		set<UMLModelTransformer::Out, ObjectSorterOut> outPortsConnect;	//the ports to which we are connecting
		UMLModelTransformer::Expression onlyExpr;	//the Expression
		bool alreadySeenExpression = false;
		bool isThisCase = true;

		for(set<Udm::Object>::iterator it = selectedObjects.begin(); it != selectedObjects.end(); ++it)
		{
			if(((*it).type()) == UMLModelTransformer::Out::meta)
			{
				UMLModelTransformer::Out currOut = UMLModelTransformer::Out::Cast(*it);
				outPorts.push_back(currOut);
			}
			else if(Uml::IsDerivedFrom( (*it).type(), UMLModelTransformer::Expression::meta))
			{
				if(!alreadySeenExpression)
				{
					onlyExpr = UMLModelTransformer::Expression::Cast(*it);
					alreadySeenExpression = true;
				}
				else isThisCase = false;  //we can't have 2 expressions in this case
			}
			else if(((*it).type()) == UMLModelTransformer::ExpressionRef::meta)
			{
				if(!alreadySeenExpression)
				{
					UMLModelTransformer::ExpressionRef tempRef = UMLModelTransformer::ExpressionRef::Cast(*it);
					onlyExpr = tempRef.ref();
					alreadySeenExpression = true;
				}
				else isThisCase = false;
			}

			else 
			{
				isThisCase = false;
				break;
			}
		}

		if(isThisCase) {
			//Now we need to sort the OutputPorts, find all of the OutputPorts in the Expression, then connect them
			outPorts.sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::Out>));
			ObjectSorterOut os;
			outPortsConnect = onlyExpr.Out_kind_children_sorted(os);
			
			set<UMLModelTransformer::Out, ObjectSorterOut>::iterator sit = outPortsConnect.begin();
			list<UMLModelTransformer::Out>::iterator lit = outPorts.begin();
			UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

			for(; (lit != outPorts.end()) && (sit != outPortsConnect.end()); ++lit, ++ sit)
			{
				UMLModelTransformer::Sequence newSequence= UMLModelTransformer::Sequence::Create(mainContainer);
				newSequence.srcSequence_end()= *sit;
				newSequence.dstSequence_end()= *lit;
			}
			return;
		}		
	}

	catch(udm_exception& e)
	{
		AfxMessageBox(e.what(),MB_OK);
	}

	try
	{
		list<UMLModelTransformer::In> inPorts;
		list<UMLModelTransformer::Out> outPorts;

		for(set<Udm::Object>::iterator it = selectedObjects.begin(); it != selectedObjects.end(); ++it)
		{
			if(((*it).type()) == UMLModelTransformer::Out::meta)
			{
				UMLModelTransformer::Out currOut = UMLModelTransformer::Out::Cast(*it);
				outPorts.push_back(currOut);
			}
			else if(((*it).type()) == UMLModelTransformer::In::meta)
			{
				UMLModelTransformer::In currIn = UMLModelTransformer::In::Cast(*it);
				inPorts.push_back(currIn);
			}
			else return;
		}

		outPorts.sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::Out>));
		inPorts.sort( std::ptr_fun( YPosCmp_caster< Udm::Object, UMLModelTransformer::In>));

		list<UMLModelTransformer::In>::iterator lit = inPorts.begin();
		list<UMLModelTransformer::Out>::iterator sit = outPorts.begin();
		UMLModelTransformer::Expression mainContainer = UMLModelTransformer::Expression::Cast(focusObject);

		for(; (lit != inPorts.end()) && (sit != outPorts.end()); ++lit, ++sit)
		{
			UMLModelTransformer::Sequence newSequence = UMLModelTransformer::Sequence::Create(mainContainer);
			newSequence.srcSequence_end()= *lit;
			newSequence.dstSequence_end()= *sit;
		}

	}

	catch(udm_exception& e)
	{
		AfxMessageBox(e.what(),MB_OK);
	}
/*
#ifdef _DEBUG
	// Displaying the name of the root object meta
	Udm::Object rootObject=p_backend->GetRootObject();
	string rootObjectName("Root Object's Class Name: ");
	rootObjectName+=ExtractName(rootObject.type());
	AfxMessageBox(rootObjectName.c_str());

	// Displaying the focus object
	string focusObjectName("Focus Object Name: ");
	focusObjectName+=ExtractName(focusObject);
	AfxMessageBox(focusObjectName.c_str());

	// Displaying selected objects
	string selObjNames("Selected Objects:\r\n");
	// Iterate set
	for(set<Udm::Object>::iterator i=selectedObjects.begin();
													i!=selectedObjects.end();i++)
	{
		selObjNames+=ExtractName(*i);
		selObjNames+="\r\n";
	}
	AfxMessageBox(selObjNames.c_str());	
#endif
	*/
/****************************** Demo Code End *************************/
													
}



#ifdef _DEBUG
/*****************************************************/
/* Debug time helper function. If the object has an  */
/* attribute called "name", this function retreives  */
/* it to help you to find it in the model during the */
/* application development.	Usualy every GME Object	 */
/* has a "name" attribute. If an object hapens not	 */
/* to have it,function retreives <no name specified>.*/
/*****************************************************/
string CUdmApp::ExtractName(Udm::Object ob)
{
	Uml::Class cls= ob.type();				
	set<Uml::Attribute> attrs=cls.attributes();		
	
	// Adding parent attributes
	set<Uml::Attribute> aattrs=Uml::AncestorAttributes(cls);
	attrs.insert(aattrs.begin(),aattrs.end());

	for(set<Uml::Attribute>::iterator ai = attrs.begin();ai != attrs.end(); ai++) 
	{
		if(string(ai->type())=="String")
		{
			string str=ai->name();
			if(str=="name")
			{
				string value=ob.getStringAttr(*ai);
				if(value.empty())value="<empty string>";
				return value;
			}			
		}				
	}	
	return string("<no name specified>");
}
#endif
