import sys
import gme
import gc
import os



def compare (file1, file2):
    with gme.Project.open(file1) as project1:
        with gme.Project.open(file2) as project2:
            return compare2(project1, project2)


def compare2(project1, project2):
    toProcess1=[]
    toProcess2=[]
    
    current1=None
    current2=None
    
    project1Root=project1.project.RootFolder
    toProcess1.append(project1Root)
    project2Root=project2.project.RootFolder
    toProcess2.append(project2Root)
    
    current1=toProcess1.pop()

    while current1!=None:
        flag=0
        
        #print current1.Name
        
        if len(toProcess2)==0:
            print "Print nothing to process for "+ current2.Name
            return False
        
        for index in range(len(toProcess2)):
            if current1.Name == toProcess2[index].Name :
                current2=toProcess2[index]
                del toProcess2[index]
                flag=1
                break
        
        if(flag==1):
            flag=0
        else:
            print "Found nothing corresponding to "+current1.Name +" of kind \"" +gme.kind(current1) +"\""
            return False
        
        if current1.AbsPath!=current2.AbsPath and current1.Name !=current2.Name :
            print current1.AbsPath," != ",current2.AbsPath
            return False
        
        #ATOMS
        if current1.ObjType == current2.ObjType and current2.ObjType ==2 :
            if compareAssoc(current1.PartOfConns,current2.PartOfConns):
                try:
                    current1=toProcess1.pop(0)
                except IndexError:
                    if len(toProcess2) == 0:
                        return True
                    else:
                        print "Atoms:: Wrong"
                        return False
                current2=None
                continue
            else:
                return False
        
        
        #REFERENCE
        if current1.ObjType == 3 and current2.ObjType == 3 :
            if compareReference(current1,current2) and compareAssoc(current1.PartOfConns,current2.PartOfConns):
                try:
                    current1=toProcess1.pop(0)
                except IndexError:
                    if len(toProcess2) == 0:
                        return True
                    else:
                        print "Reference has something"
                        return False
                current2=None
                continue
            else:
                print "compareReference FAILED for "+current1.Name+" "+current2.Name
                return False
        
        
        #Sets
        if current1.ObjType == 5 and current2.ObjType == 5:
            if compareSet(current1,current2)and compareAssoc(current1.PartOfConns,current2.PartOfConns):
                try:
                    current1=toProcess1.pop(0)
                except IndexError:
                    if len(toProcess2) == 0:
                        return True
                    else:
                        print "Set 2 has something"
                        return False
                current2=None
                continue
            else:
                print "compareSet FAILED for "+current1.Name+" "+current2.Name
                return False
        
        if current1.ObjType == 1 and current2.ObjType == 1:
            if compareAssoc(current1.PartOfConns,current2.PartOfConns):
                None
            else:
                return False
        
        #For FCO's that are connections we need to execute just this "if" block
        if current1.ObjType == 4 and current2.ObjType == 4:
            try:
                current1=toProcess1.pop(0)
            except IndexError:
                if len(toProcess2) == 0:
                    return True
                else:
                    print "CONNECTION:: Proc 2 has something"
                    return False
            current2=None
            continue
        
        
        childrenSet1=[]
        childrenSet2=[]
        
        childrenSet1=gme.cast(current1).children()
        childrenSet2=gme.cast(current2).children()
        
        """for ch in childrenSet1:
           if current1.ObjType !=4:
              print "\t"+ch.Name""" 
        
        if(len(childrenSet1)!= len(childrenSet2)):
            print "LENGTH of childrenSet FAILED for "+current1.Name
            return False
        
        #if it is a folder just check the number of children elements  and then get the next element
        if current1.ObjType == 6 and current2.ObjType == 6:
            try:
                current1=toProcess1.pop(0)
            except IndexError:
                if len(toProcess2) == 0:
                    return True
                else:
                    print "END Proc 2 has something"
                    return False
        
        if(compareChildrenNameType(childrenSet1,childrenSet2)):
            None
        else:
            print "compareChildrenNameType FAILED for "+current1.Name
            return False
        
        if(compareChildrenAttrib(childrenSet1,childrenSet2)):
            None
        else:
            print "compareChildrenAttrib FAILED for "+current1.Name
            return False
        
        for item in childrenSet1:
            toProcess1.append(item)
        
        for item in childrenSet2:
            toProcess2.append(item)
        
        try:
            current1=toProcess1.pop(0)
        except IndexError:
            if len(toProcess2) == 0:
                return True
            else:
                print "END Proc 2 has something"
                return False
current2=None


def compareSet(*setFCOs):
    array=[]
    for index in range(len(setFCOs)):
        array.append(dict())
        array[index][setFCOs[index].Name]=setFCOs[index].AbsPath
    
    for index in range(len(setFCOs)-1):
        if(array[index] != array[index+1]):
            print "Returning False from "+sys._getframe().f_code.co_name
            return False
    return True

def compareReference(*referenceFCOs):
    array=[]
    for index in range(len(referenceFCOs)):
        array.append(dict())
        array[index][referenceFCOs[index].Name]=referenceFCOs[index].AbsPath
    
    for index in range(len(referenceFCOs)-1):
        if(array[index] != array[index+1]):
            print "Returning False from "+sys._getframe().f_code.co_name
            return False
    return True
   
def compareChildrenNameType(*childrenSet):
    array=[]
    for index in range(len(childrenSet)):
        array.append(dict())
        for child in childrenSet[index]:
            array[index][child.Name+"::"+gme.OBJTYPE_MAP.get(child.ObjType)+"::"+unicode(child.Attributes.Count)]=100
            #array[index][child.Name]=child.Attributes.Count
    
    for index in range(len(childrenSet)-1):
        if(array[index] != array[index+1]):
            print "Returning False from "+sys._getframe().f_code.co_name
            return False
    return True

def compareAssoc(*current):
    array=[]
    for index in range(len(current)):
        array.append(dict())
        for point in current[index]:
            array[index][point.ConnRole]="%s %s" % (point.target.Name,point.target.AbsPath)
    
    for index in range(len(current)-1):
        if(array[index] != array[index+1]):
            print "Returning False from "+sys._getframe().f_code.co_name
            return False
    return True
def compareChildrenAttrib(*childrenSet):
    array=[]
    for index in range(len(childrenSet)):
        array.append(dict())
        for children in childrenSet[index]:
            key=children.Name
            for attr in children.Attributes: 
                array[index][key]="%s %s" % (attr.Meta.Name,attr.Value)
    
    for index in range(len(childrenSet)-1):
        if(array[index] != array[index+1]):
            print "Returning False from "+sys._getframe().f_code.co_name
            return False
    return True

if __name__ == "__main__":

    if(len(sys.argv)==3):
        file1=sys.argv[1]
        file2=sys.argv[2]
        if not os.path.isfile(file1):
            print False
        os.path.isfile(file2)
        if(compare(file1,file2)):
            print "'file1','file2' are same";
        else:
            print "'file1','file2' are not the same";
        gc.collect()
    else:
        print "Need exactly two arguments"